#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>

char *strchr(), *strrchr();
void usage();

char *argv0;

#ifdef NEEDUSLEEP
void
usleep(usec)
unsigned usec;
{
	struct timeval tmsec;

	tmsec.tv_sec = usec/1000000;
	tmsec.tv_usec = usec % 1000000;
	select(1, (fd_set *)NULL, (fd_set *)NULL, (fd_set *)NULL, &tmsec);
}
#endif

main(argc, argv)
char **argv;
{
	int vflg=0;
	int dp;
	int sec;
	int usec;
	int pow;
	int count;
	int argn;
	char *p, *s;
	struct timeval now;
	struct tm *nowtm;
	int nowhms, nowu;
	int thenhms, thenu;

	argv0=argv[0];
	if (p=strrchr(argv0, '/'))
		argv0 = &p[1];

	if (argc > 1 && strcmp(argv[1], "-v") == 0) {
		vflg=1;
		argv++;
		argc--;
	}

	if (argc > 1 && strcmp(argv[1], "--") == 0) {
		argv++;
		argc--;
	}

	/* no args means forever */
	if (argc == 1) {
		if (vflg)
			printf("forever\n");
		pause();
		exit(0);
	}

	gettimeofday(&now, NULL);
	nowu=now.tv_usec;
	nowtm=localtime(&(now.tv_sec));
	nowhms=nowtm->tm_hour*3600 + nowtm->tm_min*60 + nowtm->tm_sec;

	sec=0;
	usec=0;
	for (argn=1; argn < argc; argn++) {
		s=argv[argn];
		if (!isdigit(*s) && *s != '.') {
			fprintf(stderr, "%s: bad character '%c'\n", argv0, *s);
			usage();
		}

		count=0;
		dp=0;
		for (p=s; *p; p++) {
			if (*p == ':') {
				if (!isdigit(p[1])) {
					count=999;
					break;
				}
				count++;
			} else if (isdigit(*p)) {
				continue;
			} else if (*p == '.') {
				dp++;
			} else {
				count=999;
				break;
			}
		}
		if (count == 2 && dp < 2) {
			/* until HH:MM:SS[.SS] format */
			thenhms=atoi(s)*3600;
			p=strchr(s, ':');
			p++;
			thenhms += atoi(p)*60;
			p=strchr(p, ':');
			p++;
			thenhms += atoi(p);
			thenu=0;
			if (dp) {
				p=strchr(p, '.');
				p++;
				pow=100000;
				while (*p) {
					thenu += pow*(*p-'0');
					pow /= 10;
					p++;
				}
			}
			if (thenhms < nowhms || (thenhms == nowhms && thenu < nowu)) {
				sec += 86400+thenhms-nowhms;
				usec += thenu-nowu;
			} else {
				sec += thenhms-nowhms;
				usec += thenu-nowu;
			}
			while (usec < 0) {
				sec--;
				usec += 1000000;
			}
			if (usec >= 1000000) {
				sec += usec/1000000;
				usec = usec%1000000;
			}
			nowhms=thenhms;
			nowu=thenu;
			continue;
		}

		dp=0;
		for (p=s; *p; p++) {
			if (isdigit(*p)) {
				continue;
			}
			if (p == s && *p != '.') {
				fprintf(stderr, "%s: bad character '%c'\n", argv0, *p);
				usage();
			}
			if (*p == 'd') {
				if (dp) {
					fprintf(stderr, "%s: decimal for day not allowed\n", argv0);
					usage();
				}
				sec += atoi(s)*86400;
				s = &p[1];
				continue;
			}
			if (*p == 'h') {
				if (dp) {
					fprintf(stderr, "%s: decimal for hour not allowed\n", argv0);
					usage();
				}
				sec += atoi(s)*3600;
				nowhms += atoi(s)*3600;
				nowhms %= 86400;
				s = &p[1];
				continue;
			}
			if (*p == 'm') {
				if (dp) {
					fprintf(stderr, "%s: decimal for minute not allowed\n", argv0);
					usage();
				}
				sec += atoi(s)*60;
				nowhms += atoi(s)*60;
				nowhms %= 86400;
				s = &p[1];
				continue;
			}
			if (*p == 's') {
				sec += atoi(s);
				nowhms += atoi(s);
				nowhms %= 86400;
				s = &p[1];
				continue;
			}
			if (*p == '.') {
				sec += atoi(s);
				if (dp) {
					fprintf(stderr, "%s: two decimal points\n", argv0);
					usage();
				}
				dp=1;
				p++;
				pow=100000;
				while (isdigit(*p)) {
					usec += pow*(*p-'0');
					nowu += pow*(*p-'0');
					pow /= 10;
					p++;
				}
				if (usec >= 1000000) {
					sec += usec/1000000;
					usec = usec%1000000;
				}
				if (nowu >= 1000000) {
					nowhms += nowu/1000000;
					nowu = nowu%1000000;
				}
				if (*p == 's') {
					s = &p[1];
				} else {
					s=p;
					p--;
				}
				continue;
			}
			fprintf(stderr, "%s: bad character '%c'\n", argv0, *p);
			usage();
		}
		if (s != p) {
			sec += atoi(s);
			nowhms += atoi(s);
			nowhms %= 86400;
		}
	}

	if (vflg) {
		printf("sleep");
		count=sec;
		if (count >= 86400) {
			printf(" %dd", count/86400);
			count %= 86400;
		}
		if (count >= 3600) {
			printf(" %dh", count/3600);
			count %= 3600;
		}
		if (count >= 60) {
			printf(" %dm", count/60);
			count %= 60;
		}
		if (usec) {
			printf(" %d.", count);
			for (pow=1000000; pow > 10000 ;) {
				pow /= 10;
				printf("%d", (usec/pow)%10);
				if ((usec % pow) == 0)
					break;
			}
			printf("s");
		} else if (count)
			printf(" %ds", count);
		if (sec > 59)
			if (usec) {
				printf(" = %d.", sec);
				for (pow=1000000; pow > 10000 ;) {
					pow /= 10;
					printf("%d", (usec/pow)%10);
					if ((usec % pow) == 0)
						break;
				}
				printf(" seconds");
			} else
				printf(" = %d second%s", sec, (sec == 1?"":"s"));
		printf(" [%02d:%02d:%02d.%02d]\n", nowhms/3600, (nowhms/60)%60, nowhms%60, nowu/10000);
	}
	if (sec)
		sleep(sec);
	if (usec)
		usleep(usec);
	exit(0);
}

void
usage()
{
	fprintf(stderr, "Usage:\t%s [-v] [<days>d] [<hours>h] [<minutes>m] [<seconds>[.<decimal>][s]]\n", argv0);
	fprintf(stderr, "\t%s [-v] HH:MM:SS[.<decimal>]\t(until time of day)\n", argv0);
	fprintf(stderr, "\t%s [-v]\tno args means forever (until interrupted)\n", argv0);
	exit(2);
}
